// Pooled Websockets by Eeems (MIT Licence): https://github.com/Eeems/PooledWebSocket/blob/master/LICENSE
(function(e,n){var o={handler:null,worker:null,queue:[],events:{},postMessage:function(e,n){var r=[JSON.stringify(e),n];console.info("postMessage: "+JSON.stringify(r));o.queue.push(r);if(o.handler){o.queue.forEach(function(e){o.handler.apply(o,e)});o.queue=[]}},open:function(e,n){o.postMessage({action:"open",url:e,protocols:n})},on:function(e,n,r){o.events[n]||(o.events[n]=[]);o.events[n].push(r)}},r=function(e){o.handler=function(e){return window.postMessage.call(window,e,location.origin)};o.detach=function(e){};window.addEventListener("message",function(e){if(e.origin==location.origin){o.onmessage(e)}});e&&console.error(e);console.info("Reverting to non-pooled")};if("SharedWorker"in window){console.info("Using shared worker for pool");var t=new SharedWorker("websocketworker.min.js");o.worker=t;o.handler=function(){return t.port.postMessage.apply(t.port,arguments)};o.detach=function(e){o.postMessage({action:"detach",url:e})};t.port.onmessage=function(e){o.onmessage(e)};t.onerror=function(e){console.error(e)};t.port.start()}else if("serviceWorker"in navigator){console.info("Using service worker for pool");(function(){var e={postMessage:function(){n.push(arguments)}},n=[];o.worker=e;o.handler=function(){return e.postMessage.apply(e,arguments)};o.detach=function(e){};navigator.serviceWorker.oncontrollerchange=function(n){e=reg.active||reg.waiting||reg.installing||navigator.serviceWorker};navigator.serviceWorker.onmessage=function(e){o.onmessage(e)};navigator.serviceWorker.register("websocketworker.min.js",{}).then(function(r){console.info("Service worker registered");e=r.active||r.waiting||r.installing||navigator.serviceWorker.controller;o.worker=e;while(n.length){e.postMessage.apply(e,n.shift())}e.onstatechange=function(n){if(n.target.state!="activated"){console.info("Using new service worker");e=n.target}}}).catch(r)})()}else if("Worker"in window){console.info("Using shared worker for pool");var t=new Worker("websocketworker.min.js");o.worker=t;o.handler=function(){return t.postMessage.apply(t,arguments)};o.detach=function(e){};t.onmessage=function(e){o.onmessage(e)};t.onerror=function(e){console.error(e)}}else{e.PooledWebSocket=WebSocket;return}o.onmessage=function(e){if(e.data){var n=JSON.parse(e.data);switch(n.action){case"event":console.info("Event: "+n.event+" "+JSON.stringify(n.arguments));o.events[n.event]&&o.events[n.event].forEach(function(e){e.apply({},n.arguments)});break;case"property":o.onmessage({data:JSON.stringify({action:"event",event:"property",arguments:[n.name,n.value]})});break}}};e.PooledWebSocket=function(e,n){var r={},t={},s={},i={open:[],message:[],error:[],close:[]},a={open:[],message:[],error:[],close:[]};Object.defineProperties(r,{readyState:{get:function(){return t["readyState"]}},extensions:{get:function(){return t["extensions"]}},protocol:{get:function(){return t["protocol"]}},url:{get:function(){return t["url"]}},onopen:{get:function(){return s.onopen},set:function(e){s.onopen=e;r.runQueue("open")}},onmessage:{get:function(){return s.onmessage},set:function(e){s.onmessage=e;r.runQueue("message")}},onerror:{get:function(){return s.onerror},set:function(e){s.onerror=e;r.runQueue("error")}},onclose:{get:function(){return s.onclose},set:function(e){s.onclose=e;r.runQueue("close")}},events:{get:function(){return i}},pool:{get:function(){return o}}});r.runQueue=function(e){if(a[e]){a[e].forEach(function(n){i[e].forEach(function(e){e.apply(r,n)});s["on"+e]&&s["on"+e].apply(r,n)});if(i[e].length>0||s["on"+e]){a[e]=[]}}return r};r.fire=function(e,n){a[e].push(n);r.runQueue(e)};r.on=function(e,n){i[e]||(i[e]=[]);i[e].push(n);r.runQueue(e);return r};r.off=function(e,n){if(i[e]&&i[e].indexOf(n)!=-1){i[e].splice(i[e].indexOf(n),1)}return r};r.addEventListener=r.on;r.send=function(n){o.postMessage({action:"send",url:e,data:n})};r.detach=function(){o.detach(e)};r.close=function(){o.postMessage({action:"close",url:e})};r.reconnect=function(){r.close();o.open(e,n)};r.open=function(){if(r.readyState==3){o.open(e,n)}else{throw new Error("PooledWebSocket is already open")}};o.open(e,n);o.on(e,"open",function(){r.fire("open",arguments)});o.on(e,"message",function(){r.fire("message",arguments)});o.on(e,"property",function(e,n){t[e]=n});o.on(e,"error",function(){r.fire("error",arguments)});o.on(e,"close",function(){r.fire("close",arguments)});return r}})(window);
